angular.module('starter.controllers', [])

.controller('LandingCtrl', function ($scope,$rootScope,LoaderService, $ionicNavBarDelegate) {	
	LoaderService.hide();
	$rootScope.headColor = 'winclub_bg';
	$scope.goBack = function() {
			$ionicNavBarDelegate.back();
		};
})

.controller('ErrorCtrl', function ($scope,$rootScope,LoaderService, $ionicNavBarDelegate) {	
	LoaderService.hide();
	$rootScope.headColor = 'winclub_bg';
	$scope.goBack = function() {
			$ionicNavBarDelegate.back();
		};
})
	
.controller('LoginCtrl', function ($scope,$rootScope, $http, $state, AuthenticationService,LoaderService) {
	
	$scope.errore=false;
	
	 if(undefined != window.localStorage['point'] || undefined != window.localStorage['cliente']) 	
		 $state.go('app.home');
	
	
  $scope.message = "";
  
  $scope.user = {
    username: null,
    password: null
  };
 
  $scope.login = function() {
	LoaderService.show();
    AuthenticationService.login($scope.user);
  };
 
  $scope.$on('event:auth-loginRequired', function(e, rejection) {
    $state.go('noMenu.login');
  });
 
  $scope.$on('event:auth-loginConfirmed', function() {
	 $scope.username = null;
	 $scope.password = null;
	 $scope.errore=false;
   //  $scope.loginModal.hide();
  });
  
  $scope.$on('event:auth-login-failed', function(e, status) {
    var error = "Login failed.";
	$scope.errore=true;
    if (status == 401) {
      error = "Invalid Username or Password.";
    }
    $scope.message = error;
  });
 
  $scope.$on('event:auth-logout-complete', function() {
    $state.go('noMenu.login', {}, {reload: true, inherit: false});
  });
  
  $scope.closeLogin = function() {
    $scope.modal.hide();
  };
  
  if($rootScope.loading)
	LoaderService.hide();
		
    })
	
.controller('AppCtrl', function($scope, $ionicModal, $ionicPopup, $ionicActionSheet, $ionicSlideBoxDelegate, $ionicNavBarDelegate, $timeout, $state, $rootScope, AuthenticationService,LoaderService) {

		
		$rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
			if(toState.url!='/login' || toState.url!='/logout' || toState.url!='/disconnected')
				LoaderService.show();		
        });	

	
		
	if(undefined ==  window.localStorage['cliente'] && undefined ==  window.localStorage['point']) 
		 $state.go('noMenu.login');	
	else {
			$scope.isMenuVisible = true;
		 // SETTO ROOTSCOPE
		 // if($rootScope.cliente == undefined || $rootScope.point == undefined) 
		// {
		
			$scope.isCliente = false;
			$scope.isMaker = false;
			$scope.isPoint = false;
			if(undefined != window.localStorage['cliente']) {		
				$rootScope.cliente=JSON.parse(window.localStorage['cliente']);
				$scope.isCliente = (undefined !=  $rootScope.cliente) ? 'true' : 'false';
				$scope.isMaker = $rootScope.cliente.maker;	
				// $scope.isPoint = false;				
			}
				
			if(undefined !=  window.localStorage['point'])	{
			
				$rootScope.point=JSON.parse(window.localStorage['point']);
			//	$scope.isCliente = false;
			//	$scope.isMaker = false;
				$scope.isPoint = (undefined !=  $rootScope.point)  ? 'true' : 'false';
				if($scope.point.idCategoria==1) {
				 var today= new Date();
				 var h = today.getHours();				 
				   if(h>2 && h<=18)
						$scope.fidbackP = $rootScope.point.fidbackG;
					else
						$scope.fidbackP = $rootScope.point.fidbackS;
						
					
				}
				else 
					$scope.fidbackP = $rootScope.point.fidbackG;	
			}			
				
	//	 }
	}
	

	if ('undefined' !==  $rootScope.point &&  undefined ==  $rootScope.cliente) {
		$rootScope.headColor = 'winpoint_bg';
		$rootScope.barColor = 'winpoint_bg';
	}		
	  else{
		$rootScope.headColor = 'winclub_bg';
		$rootScope.barColor = 'winclub_bg';
	}
	
  $scope.prevSlide = function() {
    $ionicSlideBoxDelegate.previous();
  };

  $scope.slide = function(slidenum) {
    $ionicSlideBoxDelegate.slide(slidenum);
  };

  $scope.setNavTitle = function(title) {
    $ionicNavBarDelegate.setTitle(title);
  };

   $scope.goBack = function() {
    $ionicNavBarDelegate.back();
  };

  

})

.controller('HomeCtrl', function($scope, $rootScope,$state,LoaderService, $http) {
	
	var inizializzaCliente = function(user,messaggi) {
					if(null!=user) {				
						$rootScope.isCliente = true;
						$rootScope.cliente = user;
						window.localStorage['cliente'] = JSON.stringify(user);	
						
					}
										
					if(typeof messaggi !== 'undefined')  {						
						$scope.messC = messaggi;
						if(messaggi.length==10) {
								$rootScope.counterC=1;
								$scope.moreDataCanBeLoadedC = true;
								$scope.loadMoreItemsC = function() {
									
									$rootScope.counterC += 1;
																		
										$http.get('https://winclub.winfidelity.com/app/cliente/messaggiHomeClienteScroll/'+($rootScope.cliente['idCliente'])+'/'+$rootScope.counterC)
										.success(function (data) {		
										var keepGoing = true;
								angular.forEach(data['messaggi'].item, function(messaggio) {
									if(keepGoing) {										
										if(undefined == messaggio.id) {
											this.push(data['messaggi'].item);											
											keepGoing = false;
										}										
										 else 									 											
										    this.push(messaggio);											
										 
																	
									}										 	
									}, $scope.messC);
												
											if(undefined == data['messaggi'].item.length || data['messaggi'].item.length<10)
												$scope.moreDataCanBeLoadedC = false;			
											$scope.$broadcast('scroll.infiniteScrollComplete');
											
										})
										.error(function(data){
											$scope.moreDataCanBeLoadedC = false;
											if($rootScope.loading)
												LoaderService.hide();												
										});

								}

						}
					}					
								
			};
			
	var inizializzaMaker = function(messaggi,prods) {
				$rootScope.isMaker = true;
				if(typeof messaggi !== 'undefined') {
					$scope.messM = [];
					if(undefined != messaggi.id)
						$scope.messM.push(messaggi);
					else
						$scope.messM = messaggi;
					if(messaggi.length==10) {
						$rootScope.counterM=1;
						$scope.moreDataCanBeLoadedM = true;
						$scope.loadMoreItemsM = function() {
								
							$rootScope.counterM += 1;
							
							$http.get('https://winclub.winfidelity.com/app/maker/messaggiHomeMakerScroll/'+($rootScope.cliente['idCliente'])+'/'+$rootScope.counterM)
							.success(function (data) {
							console.log('loadMoreItemsM');
							var keepGoing = true;
								angular.forEach(data['messaggi'].item, function(messaggio) {
									if(keepGoing) {										
										if(undefined == messaggio.id) {
											this.push(data['messaggi'].item);
											keepGoing = false;
										}											
										 else
											this.push(messaggio);						
									}
										 	
									}, $scope.messM);	
														
								if(undefined == data['messaggi'].item.length || data['messaggi'].item.length<10)
									$scope.moreDataCanBeLoadedM = false;			
								$scope.$broadcast('scroll.infiniteScrollComplete');
							})
							.error(function(data){
								$scope.moreDataCanBeLoadedM = false;
								if($rootScope.loading)
									LoaderService.hide();									
							});

						}
					}
				}
				if(null!=prods)
					window.localStorage['prods'] = JSON.stringify(prods);
		
			};
			
	var inizializzaPoint = function(user,messaggi) {
					if(null!=user) {						
						$rootScope.isPoint = true;
						$rootScope.point = user;
						window.localStorage['point'] = JSON.stringify(user);
					}
											
					if(typeof messaggi !== 'undefined') {
						$scope.messP = messaggi;	
						
						if(messaggi.length==10) {
							$rootScope.counterP=1;
							
							$scope.moreDataCanBeLoadedP = true;
							$scope.loadMoreItemsP = function() {	
							$rootScope.counterP += 1;			
								$http.get('https://winclub.winfidelity.com/app/point/messaggiHomePointScroll/'+($rootScope.point['idPoint'])+'/'+$rootScope.counterP)
								.success(function (data) {	
								var keepGoing = true;
								angular.forEach(data['messaggi'].item, function(messaggio) {
									if(keepGoing) {										
										if(undefined == messaggio.id) {
											this.push(data['messaggi'].item);
											keepGoing = false;
										}
											
										 else
											this.push(messaggio);						
									}
										 	
									}, $scope.messP);	
															
									if(undefined == data['messaggi'].item.length || data['messaggi'].item.length<10)
										$scope.moreDataCanBeLoadedP = false;			
									$scope.$broadcast('scroll.infiniteScrollComplete');
									
								})
								.error(function(data){
									$scope.moreDataCanBeLoadedP = false;
									if($rootScope.loading)
										LoaderService.hide();	
								});

							}
						}
					}
			};
			

   if(undefined == window.localStorage['point'] && undefined == window.localStorage['cliente']) 
		$state.go('noMenu.login');		 
   else if(undefined == $rootScope.isUpdate || $rootScope.isUpdate == true) {
		if(undefined == $rootScope.loading)
			LoaderService.show();
		if(undefined == $rootScope.isUpdate)
			$rootScope.isUpdate == true;
		$http.get('https://winclub.winfidelity.com/app/aggiornaHomeApp/'+(null!=$rootScope.cliente ? $rootScope.cliente.idCliente : -1)+'/'+(null!=$rootScope.point ?  $rootScope.point.idPoint : -1))
					.success(function (data) {					
						if(undefined != data['user']['cliente'] && data['user']['cliente']['idCliente']>=0) {							
							inizializzaCliente(data['user']['cliente'],data['user']['messC']);
							if(data['user']['cliente']['maker']== true)
								inizializzaMaker(data['user']['messM'],data['user']['prods']);
							else
								$rootScope.isMaker = false;
						}						
						if(undefined != data['user']['point'] && data['user']['point']['idPoint']>=0 ) 
							inizializzaPoint(data['user']['point'],data['user']['messP']);	
							
						 if($rootScope.loading)
							LoaderService.hide();
							
		})
		.error(function(data){
				
		});	
   }
   else {
		$rootScope.isUpdate = true;
		if(undefined != $rootScope.cliente) {
			inizializzaCliente(null,$rootScope.messC);
			if($rootScope.cliente.maker == true)
					inizializzaMaker($rootScope.messM,null);
			else
				$rootScope.isMaker = false;
		}
		else
			inizializzaPoint(null,$rootScope.messP);
		
		if($rootScope.loading)
			LoaderService.hide();
   }

		
		$scope.loadNewItemsC = function() {
			$scope.messC = [];
			$rootScope.counterC = 1;		
				$http.get('https://winclub.winfidelity.com/app/cliente/messaggiHomeClienteNew/'+($rootScope.cliente['idCliente']))
				.success(function (data) {
				if(undefined != data['messaggi']) {				
					angular.forEach(data['messaggi'].item, function(messaggio) {												
							if(messaggio.id == undefined) 																
								this.push(data['messaggi'].item);																							
							else	
								this.push(messaggio);						
														
									
						}, $scope.messC);	
					if(data['messaggi'].item.length<10)		
						$scope.moreDataCanBeLoadedC = false;
					else
						$scope.moreDataCanBeLoadedC = true;
				}
																									
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
				.error(function(data){
					$scope.moreDataCanBeLoadedC = false;
					if($rootScope.loading)
						LoaderService.hide();					
				})
				.finally(function() {
			   // Stop the ion-refresher from spinning
			   $scope.$broadcast('scroll.refreshComplete');
				});
			
			
			
		}
		
		
		
	
		
		$scope.loadNewItemsM = function() {
			$scope.messM = [];
			$rootScope.counterM = 1;
				console.log('init loadNewItemsM');
				$http.get('https://winclub.winfidelity.com/app/cliente/messaggiHomeMakerNew/'+($rootScope.cliente['idCliente']))
				.success(function (data) {
				if(undefined != data['messaggi'] && data['messaggi'].item.length<10) {
					angular.forEach(data['messaggi'].item, function(messaggio) {
							
							 if(messaggio.id == undefined)
								this.splice(0, 0, data['messaggi'].item);
							else			
								this.splice(0, 0, messaggio);
						}, $scope.messM);
												
						$scope.moreDataCanBeLoadedM = false;	
				}
				else {					
					$scope.messM = 	data['messaggi'].item;
					$scope.moreDataCanBeLoadedM = true;					
				}												
							
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
				.error(function(data){
					$scope.moreDataCanBeLoadedM = false;
					if($rootScope.loading)
						LoaderService.hide();					
				})
				.finally(function() {
			   // Stop the ion-refresher from spinning
			   $scope.$broadcast('scroll.refreshComplete');
				});
			
			
			
		}
		
		
		
	
		
		$scope.loadNewItemsP = function() {
			$scope.messP = [];		
			$rootScope.counterP = 1;
				$http.get('https://winclub.winfidelity.com/app/cliente/messaggiHomePointNew/'+($rootScope.point['idPoint']))
				.success(function (data) {		
				if(undefined != data['messaggi'] && data['messaggi'].item.length<10) {
					angular.forEach(data['messaggi'].item, function(messaggio) {
							
							 if(messaggio.id == undefined)
								this.splice(0, 0, data['messaggi'].item);
							else			
								this.splice(0, 0, messaggio);
						}, $scope.messP);
												
						$scope.moreDataCanBeLoadedP = false;	
				}
				else {					
					$scope.messP = 	data['messaggi'].item;
					$scope.moreDataCanBeLoadedP = true;					
				}												
							
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
				.error(function(data){
					$scope.moreDataCanBeLoadedP = false;
					if($rootScope.loading)
						LoaderService.hide();						
				})
				.finally(function() {
			   // Stop the ion-refresher from spinning
			   $scope.$broadcast('scroll.refreshComplete');
				});
			
			
			
		}
		
	
})

.controller('FidelitySystemCtrl', function ($scope, $http, $ionicLoading,$rootScope,LoaderService) {
		 
		  $rootScope.headColor = 'winclub_bg';	
		var dateobj= new Date();
		var month=(dateobj.getMonth()+1);				
		if(undefined === $rootScope.mesi) {
			
			var year = dateobj.getFullYear();
			var pastYear = new Date(dateobj.getTime()-365*24*60*60*1000).getFullYear();
			var mesiJSON = {
				"mesi":[
					{"id":"12","nome":"Dicembre"},
					{"id":"11","nome":"Novembre"},
					{"id":"10","nome":"Ottobre"},
					{"id":"9","nome":"Settembre"},
					{"id":"8","nome":"Agosto"},
					{"id":"7","nome":"Luglio"},
					{"id":"6","nome":"Giugno"},
					{"id":"5","nome":"Maggio"},
					{"id":"4","nome":"Aprile"},
					{"id":"3","nome":"Marzo"},
					{"id":"2","nome":"Febbraio"},
					{"id":"1","nome":"Gennaio"}
				]
			};
			// ANNO CORRENTE
			var mesiArray = mesiJSON.mesi;
			$rootScope.mesi =[];

				for(var i in mesiArray) {					
					if(parseInt(mesiArray[i].id)<=month) {
						var item = mesiArray[i];
				
					$rootScope.mesi.push({ 
						"label" : mesiArray[i].nome+' '+year,
						"mese"  : mesiArray[i].id,
						"anno"       : year 
					});					
					}
			
					
				}
				
				for(var i in mesiArray) {					
						var item = mesiArray[i];
				
					$rootScope.mesi.push({ 
						"label" : mesiArray[i].nome+' '+pastYear,
						"mese"  : mesiArray[i].id,
						"anno"       : pastYear 
					});					
			
				}

			$rootScope.selectedMese = $rootScope.mesi[0];			
		}
		
								
		 $scope.meseChanged = function(selectedMese) {
		    LoaderService.show();
			$rootScope.selectedMese = selectedMese;
			$http.get('https://winclub.winfidelity.com/app/fidelitySystem/'+(($rootScope.cliente)['idCliente'])+'/'+selectedMese.mese+'/'+selectedMese.anno)
			.success(function (data) {				
				$scope.ritiri = data['ritiri'];
				$scope.fb = data['fb'];
				$scope.ptfb = data['ptfb'];				
				if($rootScope.loading)
					LoaderService.hide();
			})
			.error(function(data){
			
		});
		};

		
        $http.get('https://winclub.winfidelity.com/app/fidelitySystem/'+($rootScope.cliente['idCliente'])+'/'+$rootScope.selectedMese.mese+'/'+$rootScope.selectedMese.anno)
			.success(function (data) {
				$scope.ritiri = data['ritiri'];
				$scope.fb = data['fb'];
				$scope.ptfb = data['ptfb'];	
				LoaderService.hide();						
			})
			.error(function(data){
				console.log('ERRORE '+data);
		});
		
    })
	
.controller('PointInAttesaCtrl', function ($scope, $http, $ionicLoading,$rootScope,$ionicPopup,LoaderService) {
		  $rootScope.headColor = 'winpoint_bg';
		  if($rootScope.point.idCategoria==1) {
				 var today= new Date();
				 var h = today.getHours();	
				 
				   if(h>2 && h<=18)
						$scope.selectedFidback = $rootScope.point.fidbackG;
					else
						$scope.selectedFidback = $rootScope.point.fidbackS;
						
					
				}
				else 
					$scope.selectedFidback = $rootScope.point.fidbackG;
		  
        $http.get('https://winclub.winfidelity.com/app/richiesteInAttesa/'+($rootScope.point['idPoint'])+'')
			.success(function (data) {
				$scope.ritiri = data['richieste'];			
				if($rootScope.loading)
					LoaderService.hide();			
				
			})
			.error(function(data){
				
		});
		
		$scope.accetta = function(id,index,codice,pt) {
		
		  var confirmPopup = $ionicPopup.confirm({
				 title: '<span class="winpoint_color">Ritiro omaggio</span>',
				subTitle: "Vuoi confermare il ritiro omaggio del cliente "+codice+" di "+pt+" pt?",
				scope: $scope,
				  cancelText: 'Annulla',
				  cancelType: 'winadmin_bg',				 
				  okText: 'Conferma',
				  okType: 'winpoint_bg',				
			  });
		   confirmPopup.then(function(res) {
			 if(res) {
			 console.log('OK');			
					   $http.get('https://winclub.winfidelity.com/app/accettaRichiesteInAttesa/'+id+'/'+$rootScope.point.sconto+'/'+$rootScope.point.aliquota+'/'+$rootScope.point.scarico+'/'+$rootScope.point.idCategoria)
						.success(function (data) {
						console.log(data);
						if(data['esito']['esito']==false) {							
							 var alertPopup = $ionicPopup.alert({
							 title: '<span class="winpoint_color">Ritiro omaggio</span>',
							 template: data['esito']['errore']
						   });
						   alertPopup.then(function(res) {
						   });
						}
						else {
							$rootScope.point.rimbParz = data['esito']['totrimborso'];
							 var alertPopup = $ionicPopup.alert({
								title: '<span class="winpoint_color">Ritiro omaggio</span>',
								template: 'Ritiro eseguito con successo!',
						 		okType: 'winpoint_bg'
							 });
							alertPopup.then(function(res) {
								if(undefined != $scope.ritiri.item)
									$scope.ritiri = [];
								else
									$scope.ritiri.splice( index, 1 );
									
									
							});
						}
						
					  
				})
				.error(function(data){
				
				});
					 	 
			 } else {
			if($rootScope.loading)
						LoaderService.hide();			
			 }
		   });
		 };

		
		$scope.rifiuta = function(id,index,codice,pt) {
		
			var confirmPopup = $ionicPopup.confirm({
				title: '<span class="winpoint_color">Ritiro omaggio</span>',
				subTitle: "Vuoi eliminare il ritiro omaggio del cliente "+codice+" di "+pt+" pt?",
				scope: $scope,
				cancelText: 'Annulla',
				cancelType: 'winadmin_bg',				 
				okText: 'Elimina',
				okType: 'winpoint_bg',
			  });
		   
		   confirmPopup.then(function(res) {
			 if(res) {
					   $http.get('https://winclub.winfidelity.com/app/rifiutaRichiesteInAttesa/'+id)
						.success(function (data) {
					   var alertPopup = $ionicPopup.alert({
						 title: '<span class="winpoint_color">Ritiro omaggio</span>',
						 template: 'Ritiro cancellato con successo!',
						 		okType: 'winpoint_bg'
					   });
					   alertPopup.then(function(res) {
								if(undefined != $scope.ritiri.item)
									$scope.ritiri = [];
								else
									$scope.ritiri.splice( index, 1 );
					   });
				})
				.error(function(data){
					
				});
					 	 
			 } else {
			   console.log('You are not sure');
			 }
		   });
		   
		 };
		 
		 $scope.aggiornaRitiri = function() {		 
			$scope.ritiri = [];
			  $http.get('https://winclub.winfidelity.com/app/richiesteInAttesa/'+($rootScope.point['idPoint'])+'')
			.success(function (data) {
				$scope.ritiri = data['richieste'];			
				if($rootScope.loading)
					LoaderService.hide();			
				
			})
			.error(function(data){	
				if($rootScope.loading)
					LoaderService.hide();
		})
		.finally(function() {
       // Stop the ion-refresher from spinning
       $scope.$broadcast('scroll.refreshComplete');
		});
						

		};
 
		
    })
	
.controller('FidelitySystemPointCtrl', function ($scope, $http, $ionicLoading,$rootScope,LoaderService) {
		$rootScope.headColor = 'winpoint_bg';
		$rootScope.counter=0;
		$scope.moreDataCanBeLoaded = true;
		if($rootScope.point.idCategoria==1) {
				 var today= new Date();
				 var h = today.getHours();	
				 
				   if(h>2 && h<=18)
						$scope.selectedFidback = $rootScope.point.fidbackG;
					else
						$scope.selectedFidback = $rootScope.point.fidbackS;
						
					
				}
				else 
					$scope.selectedFidback = $rootScope.point.fidbackG;
					
					$scope.sconto =  $rootScope.point.sconto;
					
		$scope.ritiri = [];
		var dateobj= new Date();
		var month=(dateobj.getMonth()+1);				
		if(undefined === $rootScope.mesi) {
			
			var year = dateobj.getFullYear();
			var pastYear = new Date(dateobj.getTime()-365*24*60*60*1000).getFullYear();
			var mesiJSON = {
				"mesi":[
					{"id":"12","nome":"Dicembre"},
					{"id":"11","nome":"Novembre"},
					{"id":"10","nome":"Ottobre"},
					{"id":"9","nome":"Settembre"},
					{"id":"8","nome":"Agosto"},
					{"id":"7","nome":"Luglio"},
					{"id":"6","nome":"Giugno"},
					{"id":"5","nome":"Maggio"},
					{"id":"4","nome":"Aprile"},
					{"id":"3","nome":"Marzo"},
					{"id":"2","nome":"Febbraio"},
					{"id":"1","nome":"Gennaio"}
				]
			};
			// ANNO CORRENTE
			var mesiArray = mesiJSON.mesi;
			$rootScope.mesi =[];

				for(var i in mesiArray) {					
					if(parseInt(mesiArray[i].id)<=month) {
						var item = mesiArray[i];
				
					$rootScope.mesi.push({ 
						"label" : mesiArray[i].nome+' '+year,
						"mese"  : mesiArray[i].id,
						"anno"       : year 
					});					
					}
			
					
				}
				
				for(var i in mesiArray) {					
						var item = mesiArray[i];
				
					$rootScope.mesi.push({ 
						"label" : mesiArray[i].nome+' '+pastYear,
						"mese"  : mesiArray[i].id,
						"anno"       : pastYear 
					});					
			
				}

			$rootScope.selectedMese = $rootScope.mesi[0];			
		}
		
								
		 $scope.meseChanged = function(selectedMese) {
		    LoaderService.show();
			$rootScope.counter=0;
			$scope.moreDataCanBeLoaded = true;
			$scope.ritiri = [];
			$rootScope.selectedMese = selectedMese;
			$scope.loadMoreItems();
			if($rootScope.loading)
				LoaderService.hide();			

		};
		
       
		
		$scope.loadMoreItems = function() {
			
			var length=0;			
			$rootScope.counter += 1;
			
			var isBusy = false;
			if($rootScope.counter==1) {
				isBusy = true;
				 $http.get('https://winclub.winfidelity.com/app/fidelitySystemPoint/'+($rootScope.point['idPoint'])+'/'+$rootScope.selectedMese.mese+'/'+$rootScope.selectedMese.anno)
				.success(function (data) {				
					angular.forEach(data['ritiri'], function(ritiri) {								  
								length += 1;							
							 this.push(ritiri);	
						}, $scope.ritiri);	
					$scope.totritiri = data['totritiri'];
					$scope.nmrritiri = data['nmrritiri'];
					$scope.totrimborsi = data['totrimborsi'];
					if(undefined == $scope.ritiri.length || $scope.ritiri.length<30)
						$scope.moreDataCanBeLoaded = false;	
					if($rootScope.loading) {
					
					LoaderService.hide();
					}
							
					$scope.$broadcast('scroll.infiniteScrollComplete');
					
			})
			.error(function(data){

		});
			}
			else if($scope.moreDataCanBeLoaded == true && !isBusy) {
				console.log($rootScope.counter);
				$http.get('https://winclub.winfidelity.com/app/fidelitySystemPointPaging/'+($rootScope.point['idPoint'])+'/'+$rootScope.selectedMese.mese+'/'+$rootScope.selectedMese.anno+'/'+$rootScope.counter)
				.success(function (data) {		
				angular.forEach(data['ritiri'], function(ritiri) {								  
								length += 1;							
							 this.push(ritiri);	
						}, $scope.ritiri);					
					if($scope.ritiri.length%30!=0)
						$scope.moreDataCanBeLoaded = false;			
					$scope.$broadcast('scroll.infiniteScrollComplete');
				})
				.error(function(data){
	
				});
			}
			
			
		}
		
		$scope.$on('stateChangeSuccess', function() {
			$scope.loadMoreItems();
		});
		
    })

.controller('PointCtrl', function ($scope, points , $ionicLoading, $filter,$rootScope, $ionicActionSheet, $window, $document, $timeout, $ionicScrollDelegate,$ionicModal,cacheService,LoaderService,$http,$state) {
		 
		 var today= new Date();
		  var h = today.getHours();	
		  if(h>2 && h<=18)
				$scope.fascia = 'pranzo';
			else
				$scope.fascia = 'cena';
		 $rootScope.headColor = 'winpoint_bg';
		 $rootScope.counter=1;
		 $rootScope.isLazyEnabled=true;
		 $scope.maxCounter=1;
		 $scope.geo = false;
		 $scope.nmrPoint=0;
		 $scope.ordine=1;
		 $scope.cssCat='point';
		 $scope.cat='Tutti';
		 $scope.cache= cacheService;
		 
		console.log((typeof $scope.value == 'undefined' && typeof $scope.cache != 'undefined' && typeof $scope.cache.testo == 'undefined'));
		 $scope.headerBarVisible = (typeof $scope.value == 'undefined' && typeof $scope.cache.testo == 'undefined');
		 $scope.cache= cacheService;
		 if(undefined != $scope.cache.km)
			$scope.km=$scope.cache.km;
		 else {
			$scope.km=20;
			$scope.cache.km=20;
		 }
		 if(undefined != $scope.cache.cssCat)
			$scope.cssCat=$scope.cache.cssCat;
		else {
			$scope.cssCat='point';
			$scope.cache.cssCat='point';
		 }
		 if(undefined != $scope.cache.cat)
			$scope.cat=$scope.cache.cat;
		 else {
			$scope.cat='Tutti';
			$scope.cache.cat='Tutti';
		 }
		 if(undefined != $scope.cache.ordine)
			$scope.ordine=$scope.cache.ordine;
		else {
			$scope.ordine=1;
			$scope.cache.ordine=1;
		 }	
		if(undefined != $scope.cache.testo)
			$scope.value=$scope.cache.testo;
		else {
			$scope.value= undefined;
			$scope.cache.testo= undefined;
		 }	
			
		 var filtraPointNew = function(isKm) {
				
				 $scope.geo = undefined != window.localStorage['lon'] ? true : false;	
				if(isKm==true && (undefined != $scope.km || undefined != $scope.cache.km ) && $scope.geo==true) {
					if(undefined != $scope.cache.km && undefined != $scope.km)
						$scope.cache.km=$scope.km;
					else if(undefined != $scope.km)
						$scope.cache.km=$scope.km;
					else
						$scope.km=$scope.cache.km;
					
								
					$scope.pointsNoFiltered = $filter('filtraDistanza')($rootScope.points,$scope.km);
				}
				
					pointsNoFiltered = $scope.pointsNoFiltered;
									
				if(undefined != $scope.value || undefined != $scope.cache.value) {
					if(undefined != $scope.cache.value && undefined != $scope.value)
						$scope.cache.value=$scope.value;
					else if(undefined != $scope.value)
						$scope.cache.value=$scope.value;
					else
						$scope.value=$scope.cache.value;
						
						
					pointsNoFiltered = $filter('filtraNome')(pointsNoFiltered,$scope.value);
				}
					
				if(((undefined != $scope.cssCat || undefined != $scope.cache.cssCat) && $scope.cssCat!='point')  ) {
					if(undefined != $scope.cache.cssCat && undefined != $scope.cssCat) {
						$scope.cache.cssCat=$scope.cssCat;
						$scope.cache.cat=$scope.cat;
					}				
					else if(undefined != $scope.cssCat) {
						$scope.cache.cssCat=$scope.cssCat;
						$scope.cache.cat=$scope.cat;
					}						
					else {
						$scope.cssCat=$scope.cache.cssCat;
						$scope.cache.cat=$scope.cat;
					}
					
					
					pointsNoFiltered = $filter('filtraCategoria')(pointsNoFiltered,$scope.cssCat);
				}
				else if($scope.cssCat=='point')	{
					$scope.cache.cssCat=$scope.cssCat;
					$scope.cache.cat=$scope.cat;
				}				
				
							
				if($scope.cache.ordine==0)
					$scope.points = $filter('orderBy')(pointsNoFiltered, '-dist', true);
				else if($scope.cache.ordine==1)	
					$scope.points = $filter('orderBy')(pointsNoFiltered, ['fidback*1','-nomePoint'], true);
				else if($scope.cache.ordine==2)	
					$scope.points = $filter('orderBy')(pointsNoFiltered, '-nomePoint', true);
				else if($scope.cache.ordine==3)	
					$scope.points = $filter('orderBy')(pointsNoFiltered, 'nomePoint', true);
					
				$scope.maxCounter=Math.ceil($scope.points.length/10);
				$scope.nmrPoint=$scope.points.length;			
				$rootScope.counter = 1;
				$ionicScrollDelegate.scrollTop();				
				if($rootScope.loading)
					LoaderService.hide();
			};
			
		  
			
			// Triggered on a button click, or some other target
			   $scope.show = function() {

			   
				 // Show the action sheet
				 var hideSheet = $ionicActionSheet.show({
				   buttons: [
					 { text: 'Entro 20 km' },
					 { text: 'Entro 50 km' },
					 { text: 'Entro 100 km' },
					 { text: 'Entro 200 km' }
				   ],
				   titleText: '<span class="glyphicon glyphicon-road"></span> Cerca entro',
				   cancelText: 'Annulla',
				   cancel: function() {
						// add cancel code..
					  },
				   buttonClicked: function(index) {
				   if(index==0)
						$scope.km=20;
				   else if(index==1)
						$scope.km=50;
					else if(index==2)
						$scope.km=100
					else
						$scope.km=200;
					
					$scope.cache.km=$scope.km;	
					 filtraPointNew(true);
					 return true;
				   }
				 });

			   };

			   // Triggered on a button click, or some other target
			   $scope.showDist = function() {

			   
				 // Show the action sheet
				 var hideSheet = $ionicActionSheet.show({
				   buttons: [
					 { text: 'Dal pi&ugrave; vicino <span class="actionsheet_icon winpoint_color icon ion-map"></span>' },
					 { text: 'Con il FIDBack maggiore <span class="actionsheet_icon winpoint_color wicon wicon-fidback"></span>' },
					 { text: 'In ordine alfabetico A-Z <span class="actionsheet_icon winpoint_color glyphicon glyphicon-sort-by-alphabet"></span>' },
					 { text: 'In ordine alfabetico Z-A <span class="actionsheet_icon winpoint_color glyphicon glyphicon-sort-by-alphabet-alt"></span>'}
				   ],
				   titleText: '<span class="icon ion-arrow-swap"></span> Ordina i WINPoint',
				   cancelText: 'Annulla',
				   cancel: function() {
						// add cancel code..
					  },
				   buttonClicked: function(index) {				  
						$scope.ordine=index;				  
					
					$scope.cache.ordine=$scope.ordine;	
					 filtraPointNew(true);
					 return true;
				   }
				 });

			   };
			   
			   $scope.showPosition = function (position) {	
							   
					 window.localStorage['lat']	= 	position.coords.latitude;
					 window.localStorage['lon']	= 	position.coords.longitude;
										 
					 filtraPointNew(undefined != window.localStorage['lon'] ? true : false);
				}
 
				$scope.showError = function (error) {					
					 $http.get('https://winclub.winfidelity.com/app/indMarketing/'+($rootScope.cliente)['idCliente'])
						.success(function (data) {
								
								GMaps.geocode({								 
								  address: data['ind'],
								  callback: function(results, status) {
									if (status == 'OK') {
										
										 var latlng2 = results[0].geometry.location;
										 window.localStorage['lat']	= latlng2.lat();
										 window.localStorage['lon']	= latlng2.lng();										
										 filtraPointNew(true);
										 $scope.$apply();
										
									}
									else {
										
										filtraPointNew(false);
										$scope.$apply();
									}
									
								  }
								});
						})
						.error(function(data){
						filtraPointNew(false);
						$scope.$apply();
					});
					
				}
 
				$scope.getLocation = function () {
				
					if (navigator.geolocation) {	
						var options = {
						  enableHighAccuracy: true,
						  timeout: 5000,
						  maximumAge: 0
						};
						navigator.geolocation.getCurrentPosition($scope.showPosition, $scope.showError, options);						
						if(undefined == $scope.km) {
							$scope.km=20;
							$scope.cache.km=20;
						}
						
					}
					else {
						
						filtraPointNew(false);
						$scope.$apply();
					}
				}
		
		
		
			var today= new Date();
			var dateFormatted= today.getDate()+''+(today.getMonth()+1)+''+(today.getYear()+1900);
			var h = today.getHours();
			if(h>=3 && h<=18) {
				dateFormatted+='G';
				nomeFile='Pranzo';
			}			
			else if(h>=0 && h<3){
				today.setDate(today.getDate() - 1);
				dateFormatted= today.getDate()+''+(today.getMonth()+1)+''+(today.getYear()+1900);
				dateFormatted+='S';
				nomeFile='Cena';
			}
			else {
				dateFormatted+='S';
				nomeFile='Cena';
			}
				
			if(undefined == window.localStorage['points'] || null == window.localStorage['points'] || (undefined !=window.localStorage['points_data'] && window.localStorage['points_data']!=dateFormatted)) {
				
				var deferred = $q.defer();
				$.ajax({
						url: "http://www.winfidelity.com/json/point"+nomeFile+".json?format=json",
						dataType: "jsonp",
						cache:false,
						crossDomain: true,
						async: false,
						jsonpCallback:'points',//<<<
						success: function(result) {								
						window.localStorage['points'] = JSON.stringify(result);
						window.localStorage['points_data'] = dateFormatted;
						$rootScope.points = JSON.parse(window.localStorage['points']);							
						}, 
						error: function(request, status, error) { $state.go('app.error'); } 
					});
				
					
					
			
			}
		
		
		
		if(undefined == $rootScope.points) 
			$rootScope.points = JSON.parse(window.localStorage['points']);
		
		$scope.pointsNoFiltered = $rootScope.points;
		var pointsNoFiltered = $rootScope.points;		
		$scope.points= $rootScope.points;
		// if('undefined' == window.localStorage['lat'] || null==window.localStorage['lat'])
			$scope.getLocation();
		// else
			// filtraPointNew(true);	
		
		

		$scope.loadMoreItems = function() {	
			
			$rootScope.counter += 1;
			
			$scope.$broadcast('scroll.infiniteScrollComplete');
		}

		$scope.moreDataCanBeLoaded = function() {
			return $rootScope.counter < $scope.maxCounter;
		}
		
		$scope.cerca = function() {					
				filtraPointNew(false);				
		};
		
		$scope.hideBar = function() {					
			$scope.headerBarVisible = false;			
		};
		
		$scope.showBar = function() {			
			$scope.headerBarVisible = true;
			$scope.cache.value = undefined;
			$scope.value = undefined;		
			filtraPointNew(true);
						
		};
				
		
		// MODALE CATEGORIE
		  $ionicModal.fromTemplateUrl('categorie.html', {
			  scope: $scope,
			  backdropClickToClose: false,
			  animation: 'slide-in-up'
			}).then(function(modal) {
			  $scope.modalcat = modal;
			});
			
			// APERTURA MODALE CAT
		  $scope.openCat = function() {			
			$scope.modalcat.show();
		  };
		  
		  // CHIUSURA MODALE CAT
			$scope.closeRitiro = function() {
			  $scope.modalcat.hide();
			};
			
			$scope.scegli = function(cssCat,cat) {
				$scope.cssCat=cssCat;
				$scope.cat=cat;
				filtraPointNew(false);
				$scope.modalcat.hide();
			};

    })
	
	.filter('lazyLoad', function($rootScope) {
				$rootScope.isLazyEnabled=false;
				return function(items) {
			
			// $('div.lazy').lazyload({
				 // effect : "fadeIn"
			// });
				return items.slice(0, 10 * $rootScope.counter);
			};
				
			
		})
		
		.filter('filtraNome', function() {
				return function(items,value) {
					
					var pointsFiltered = [];
					angular.forEach(items, function(item) {
							if(null!=item.nomePoint.toLowerCase().match(value.toLowerCase()))
								this.push(item);
					}, pointsFiltered);	
					
					return pointsFiltered;					
				};
				
			
		 })
		 
		 .filter('filtraCategoria', function() {
				return function(items,value) {

					var pointsFiltered = [];
					angular.forEach(items, function(item) {
							if(null!=item.img.toLowerCase().match(value.toLowerCase()))
								this.push(item);
					}, pointsFiltered);	
					
					return pointsFiltered;					
				};
				
			
		 })
		 
		 .filter('filtraDistanza', function() {
				return function(items,value) {					
					var pointsFiltered = [];
					angular.forEach(items, function(point) {
						var dist = google.maps.geometry.spherical.computeDistanceBetween(
						new google.maps.LatLng(window.localStorage['lat'], window.localStorage['lon']), new google.maps.LatLng(point.lat, point.lon))/1000;
						point['dist'] = dist;
						//point['logo'] = point['logo'].replace('/Foto/Point','');
					    if(dist<=value) 
						 this.push(point);	
					}, pointsFiltered);				
					return pointsFiltered;					
				};
				
			
		 })

		
	.filter('myCurrency', ['$filter', function ($filter) {
		  return function(input) {
			input = parseFloat(input.replace(",", ""));
			if(input % 1 === 0) {
			  input = input.toFixed(0);
			}
			return input;
		  };
		}])	
	
	.controller('PointDetCtrl', function ($scope, $http, $ionicLoading, $stateParams, $ionicPopup, $ionicModal,$rootScope,LoaderService) {
		$rootScope.headColor = 'winpoint_bg';
		$scope.ritiro = {
			importo: '',
			pin: '',
			voto: ''
		};
		
		 $scope.goToSito = function() {
		      window.open(encodeURI($scope.url), '_system', 'location=yes');
		    };
			
        $http.get('https://winclub.winfidelity.com/app/vediDettaglioPoint/'+$stateParams.id)
			.success(function (data) {
				$scope.scheda = data['scheda'];	
				$scope.url = 'http://www.win4point.com/'+data['scheda']['url']+'.html';
				
				if($scope.scheda.cat=='Ristorazione') {
				 var today= new Date();
				 var h = today.getHours();	
				 
				   if(h>2 && h<=18)
						$scope.selectedFidback = $scope.scheda.fidbackGiorno*0.8;
					else
						$scope.selectedFidback = $scope.scheda.fidbackNotte*0.8;
						
					
				}
				else 
					$scope.selectedFidback = $scope.scheda.fidbackGiorno*0.8;
								
				if($rootScope.loading)
					LoaderService.hide();
			})
			.error(function(data){
			
		});
		
		
				 // MODALE RITIRO OMAGGIO
		  $ionicModal.fromTemplateUrl('ritiro.html', {
			  scope: $scope,
			  backdropClickToClose: false,
			  animation: 'slide-in-up'
			}).then(function(modal) {
			  $scope.modalpic = modal;
			});

		   // CHIUSURA MODALE
			$scope.closeRitiro = function() {
			  $scope.modalpic.hide();
			};

		  // APERTURA MODALE
		  $scope.openRitiro = function() {
			  $scope.ritiro = {
				importo: '',
				pin: '',
				voto: ''
			};
			$scope.modalpic.show();
		  };

		  // RITIRO OMAGGIO
		  $scope.richiestaRitiro = function() {
			 LoaderService.show();
			
			$http({
                method: 'POST',
                url: 'https://winclub.winfidelity.com/app/richiestaOmaggio',
                data: 'idCliente='+(($rootScope.cliente)['idCliente'])+'&importo='+$scope.ritiro.importo+'&pin='+$scope.ritiro.pin+'&voto='+$scope.ritiro.voto+'&idPoint='+$stateParams.id+'&fidback='+$scope.selectedFidback+'&sw='+(($rootScope.cliente)['sw']+'&isFidelity='+$scope.scheda.fidelity),
                headers: {'Content-Type': 'application/x-www-form-urlencoded'}
            })
			.success(function (data) {						
						LoaderService.hide();
						if(data['esito']['esito']==false) {
							 var alertPopup = $ionicPopup.alert({
							 title: 'Richiesta non accettata',
							 template: data['esito']['errore'],
							 okText: 'Chiudi',
							 okType: 'winpoint_bg'
						   });
						   alertPopup.then(function(res) {
								LoaderService.hide();
						   });
						}
						else {
						     $scope.ritiro = {
								importo: '',
								pin: '',
								voto: ''
							};
							 var alertPopup = $ionicPopup.alert({
								title: 'Richiesta inoltrata',
								template: 'Attendi la conferma dal WINPoint',
							    okText: 'Chiudi',
							    okType: 'winpoint_bg'
							 });
							alertPopup.then(function(res) {
								LoaderService.hide();
								
							});
						}
			})
			.error(function(data){
				$scope.loadingIndicator.hide();
				$scope.modal.hide();
			});
			
		  };

		  /* IMAGE FULLSCREEN */
		    $ionicModal.fromTemplateUrl('fullscreen.html', {
		        scope: $scope,
		        animation: 'slide-in-up'
		      }).then(function(modal) {
		        $scope.modal = modal;
		      });

		    $scope.showImage = function(img){
		    $scope.imageSrc = img;
		    $scope.modal.show();
		    };

		    $scope.closeModal = function() {
		      $scope.modal.hide();
		    };
			
			
		  
		
    })
	
	.controller('DealCtrl', function ($scope, $http,LoaderService,$rootScope) {
		$rootScope.headColor = 'windeal_bg';
        $http.get('https://winclub.winfidelity.com/app/deal/elenco')
			.success(function (data) {
				$scope.deals = data['prodotti'];
				$scope.selectEl = function(){
					angular.element(document.querySelector('.footer_point.fdeal .button.tempo .time')).addClass('winclub_bg');
				}
				if($rootScope.loading)
					LoaderService.hide();
			})
			.error(function(data){
			
		});
		
		
    })
	
	.controller('DealDetCtrl', function ($scope, $http, $stateParams, $ionicPopup,$ionicLoading,$ionicModal,$rootScope,LoaderService) {
		$rootScope.headColor = 'windeal_bg';
        $http.get('https://winclub.winfidelity.com/app/deal/'+$stateParams.id)
			.success(function (data) {
				$scope.deal = data['deal'];
				$scope.immagini = data['deal']['immagini'];				
				$this = $( "#countdowninner");
				 if(new Date(data['deal']['prodotto']['fine'])-new Date()>0) {
					$scope.isValido=true;
					// var newYear = new Date(data['deal']['prodotto']['fine']);
					// $this.countdown({until: newYear, format: 'dHMs',layout: '{d<}{dn} {dl}{d>} {hnn}{sep}{mnn}{sep}{snn} {desc}'});
				 }					
				 else
					 $scope.isValido=false;
					 
				if($rootScope.loading)
					LoaderService.hide();
			})
			.error(function(data){
			
		});
		
		 
		 $scope.showConfirm = function($titolo,$importo,$id,$idPoint) {
     
	 var ritiraDeal = $ionicPopup.confirm({
        title: '<span class="windeal_color">Ritiro WINDeal</span>',
        subTitle: '',
        template: '<span>'+$titolo+'</span><span class="popup_importo windeal_color">'+$importo+'</span>',
        cancelText: 'Annulla',
        cancelType: 'winadmin_bg',
        okText: 'Conferma',
        okType: 'windeal_bg'
     });
     ritiraDeal.then(function(res) {
       if(res) {
		LoaderService.show();
		 $http({
                method: 'POST',
                url: 'https://winclub.winfidelity.com/app/deal/ritiraDeal',
                data: 'idCliente='+(($rootScope.cliente)['idCliente'])+'&idDeal='+$id+'&importo='+$importo+'&idPoint='+$idPoint+'&titolo='+$titolo,
                headers: {'Content-Type': 'application/x-www-form-urlencoded'}
            })
			.success(function (data) {
						if($rootScope.loading)
						LoaderService.hide();	
						if(data['esito']['esito']==false) {
							 var alertPopup = $ionicPopup.alert({
							 title: 'WINDeal',
							 template: data['esito']['errore'],
							 okText: 'Chiudi',
							 okType: 'windeal_bg'
						   });
						   alertPopup.then(function(res) {
						   });
						}
						else {
							 var alertPopup = $ionicPopup.alert({
								title: 'WINDeal',
								template: 'Ritiro eseguito con successo!',
							    okText: 'Chiudi',
							    okType: 'windeal_bg'
							 });
							alertPopup.then(function(res) {
								$state.go('deal');
							});
						}
			})
			.error(function(data){
				
		});
		
       } else {
         console.log('You are not sure');
       }
     });
   };
   
   /* IMAGE FULLSCREEN */
    $ionicModal.fromTemplateUrl('fullscreen.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

    $scope.showImage = function(img){
    $scope.imageSrc = img;
    $scope.modal.show();
    };

    $scope.closeModal = function() {
      $scope.modal.hide();
    };

		
    })
	
	.controller('DealStoricoCtrl', function ($scope, $http,$rootScope,LoaderService) {
		$rootScope.headColor = 'windeal_bg';
		$scope.date = new Date();
        $http.get('https://winclub.winfidelity.com/app/deal/elencoStorico/'+($rootScope.cliente['idCliente']))
			.success(function (data) {
				$scope.deals = data['deals'];
				if($rootScope.loading)
				LoaderService.hide();
			})
			.error(function(data){
			
		});

    })
	
	.controller('MakerProfiloCtrl', function ($scope, $http,$rootScope, $stateParams,cacheService,LoaderService) {
		$rootScope.headColor = 'winmaker_bg';
		$scope.cache= cacheService;
		if(undefined === $rootScope.prods) {
			$rootScope.prods = JSON.parse(window.localStorage['prods']);
			$rootScope.selectedItem = $rootScope.prods[0];			
		}
		
		 $scope.prodChanged = function(selectedProd) {
			LoaderService.show();
			$rootScope.selectedItem = selectedProd;
			$http.get('https://winclub.winfidelity.com/app/maker/profilo/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {	
				$scope.cache.maker = data['profilo'];
				$scope.user = $scope.cache.maker;
				$scope.idAgente = $stateParams.id;
				if($rootScope.loading)
				LoaderService.hide();
				
			})
			.error(function(data){
			
			});
		};
       
		if(undefined !== $scope.cache.maker && $stateParams.id==$scope.cache.maker['id']) {			
				$scope.user = $scope.cache.maker;
				$scope.idAgente = $stateParams.id;
				if($rootScope.loading)
				LoaderService.hide();
		}
		else {
			$http.get('https://winclub.winfidelity.com/app/maker/profilo/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {	
				$scope.cache.maker = data['profilo'];
				$scope.user = $scope.cache.maker;
				$scope.idAgente = $stateParams.id;
				if($rootScope.loading)
				LoaderService.hide();
			})
			.error(function(data){
			
			});
		 }
        

    })
	
	.controller('MakerContrattiDettCtrl', function ($scope, $http,$rootScope, $stateParams,LoaderService,$ionicScrollDelegate) {
		$rootScope.headColor = 'winmaker_bg';
		$scope.headerBarVisible = true;
		if(undefined === $rootScope.prods) {
			$rootScope.prods = JSON.parse(window.localStorage['prods']);
			$rootScope.selectedItem = $rootScope.prods[0];			
		}
		 $scope.contratti = [];
		 $scope.isTrovato = false;
		 $rootScope.counter=0;
		 $rootScope.isLazyEnabled=true;
		 $scope.moreDataCanBeLoaded = true;
		 $scope.cat = $stateParams.cat;

			var riavvia  = function() {
				$rootScope.counter=0;			
				$scope.moreDataCanBeLoaded = true;
				$scope.loadMoreItems();
			}
			
			$scope.loadMoreItems = function() {
			$rootScope.counter += 1;
					
			$http.get('https://winclub.winfidelity.com/app/maker/contrattidett/'+$stateParams.id+'/'+$stateParams.cat+'/'+$stateParams.tipo+'/'+$rootScope.counter+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened+'/'+$scope.value)
			.success(function (data) {
				 var length=0;
				if($rootScope.loading)
				LoaderService.hide();
			angular.forEach(data['contratti'], function(contratti) {
						if(undefined == contratti.contratti.length)
							length += 1;	
						else
							length += contratti.contratti.length;	
						 this.push(contratti);	
					}, $scope.contratti);				
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if(undefined == data['contratti'].length || length<30)
					$scope.moreDataCanBeLoaded = false;

			})
			.error(function(data){
			
			});
			
		}
		
		$('input#cerca').keypress( _.debounce( function(){cerca()}, 500 ) );
		
		var cerca = function() {
			$scope.isTrovato = true;
			$scope.isBusy = false;
			if(!$scope.isBusy) {
			$scope.isBusy = true;
			$rootScope.counter=1;
			$scope.contratti=[];
			$scope.moreDataCanBeLoaded = false;
			$http.get('https://winclub.winfidelity.com/app/maker/contrattidett/'+$stateParams.id+'/'+$stateParams.cat+'/'+$stateParams.tipo+'/'+$rootScope.counter+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened+'/'+$scope.value)
			.success(function (data) {
				console.log($scope.value);
				angular.forEach(data['contratti'], function(contratti) {
						if(undefined == contratti.contratti.length)
							length += 1;	
						else
							length += contratti.contratti.length;	
						 this.push(contratti);	
					}, $scope.contratti);
				if(undefined == data['contratti'].length || length<30)
					$scope.moreDataCanBeLoaded = false;
				else if (length==30)
					$scope.moreDataCanBeLoaded = true;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				$ionicScrollDelegate.scrollTop();
				$scope.isBusy = false;		
			})
			.error(function(data){			
				$scope.isBusy = false;
					
			});
		}
		}
		
		

		$scope.$on('stateChangeSuccess', function() {
			$scope.loadMoreItems();
		});
		
		$scope.hideBar = function() {					
			$scope.headerBarVisible = false;			
		};
		
		$scope.showBar = function() {
			$scope.headerBarVisible = true;
			$scope.contratti = [];
			$scope.value = undefined;
			if($scope.isTrovato==true)
				riavvia();
		};
        

    })
	
	
	.controller('MakerStrutturaCtrl', function ($scope, $http,$rootScope, $stateParams, $ionicNavBarDelegate,cacheService,LoaderService,$ionicScrollDelegate) {
		console.log('MakerStrutturaCtrl' );
		$rootScope.headColor = 'winmaker_bg';
		$scope.cache= cacheService;
		$scope.headerBarVisible = true;
		$scope.moreDataCanBeLoaded = false;
		$scope.isTrovato=false;
		if(undefined === $rootScope.prods) {
			$rootScope.prods = JSON.parse(window.localStorage['prods']);
			$rootScope.selectedItem = $rootScope.prods[0];			
		}
		console.log('stateParams: '+$stateParams.id );
		if(''==$stateParams.id ) {
			if(undefined != $scope.cache.maker)
				$stateParams.id = $scope.cache.maker['id'];
			else
				$stateParams.id = $rootScope.cliente.idCliente;
		}
		
        $http.get('https://winclub.winfidelity.com/app/maker/struttura/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {
				$scope.idAgente = $rootScope.cliente.idCliente;
			    $scope.makers = data['profilo'];
				if($rootScope.loading)
				LoaderService.hide();				
			})
			.error(function(data){
			
		});
		
		var riavvia  = function() {
				$rootScope.counter=0;			
				$scope.moreDataCanBeLoaded = true;
				$ionicScrollDelegate.scrollTop();
				$scope.loadMoreItems();
				
			}
			
		$scope.loadMoreItems = function() {
			$rootScope.counter += 1;		
						
			$http.get('https://winclub.winfidelity.com/app/maker/strutturaByNome/'+$scope.value+'/'+($rootScope.cliente['idCliente'])+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened+'/'+$rootScope.counter)
			.success(function (data) {
				 var length=0;
				
			angular.forEach(data['profilo'], function(profilo) {
						 this.push(profilo);	
					}, $scope.makers);	
				console.log(data['profilo'].length);					
				$scope.$broadcast('scroll.infiniteScrollComplete');
				if(undefined == data['profilo'].length || data['profilo'].length<30)
					$scope.moreDataCanBeLoaded = false;

			})
			.error(function(data){
			
			});
			
		}
		
		$scope.goBack = function() {
			$ionicNavBarDelegate.back();
		};
		
		$('input#cerca').keypress( _.debounce( function(){cerca()}, 500 ) );
		
		var cerca = function() {
			$rootScope.counter=1;
			$scope.makers=[];
			$scope.moreDataCanBeLoaded = true;
			$http.get('https://winclub.winfidelity.com/app/maker/strutturaByNome/'+$scope.value+'/'+($rootScope.cliente['idCliente'])+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened+'/'+$rootScope.counter)
			.success(function (data) {
				
			    $scope.makers = data['profilo'];
				$ionicScrollDelegate.scrollTop();			
			})
			.error(function(data){
			
			});
		};
		
		$scope.prodChanged = function(selectedProd) {
			LoaderService.show();
			$rootScope.selectedItem = selectedProd;
			$http.get('https://winclub.winfidelity.com/app/maker/struttura/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {
				$scope.idAgente = $rootScope.cliente.idCliente;
			    $scope.makers = data['profilo'];
				if($rootScope.loading)
				LoaderService.hide();
			})
			.error(function(data){
			
		});
		};
		
		$scope.hideBar = function() {					
			$scope.headerBarVisible = false;			
		};
		
		$scope.showBar = function() {
			$scope.headerBarVisible = true;
			$scope.makers = [];
			$scope.value = undefined;
				$http.get('https://winclub.winfidelity.com/app/maker/struttura/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {
				$scope.idAgente = $rootScope.cliente.idCliente;
			    $scope.makers = data['profilo'];
				$ionicScrollDelegate.scrollTop();				
			})
			.error(function(data){
			
		});
		};

    })
	
	.controller('ContrattiCtrl', function ($scope, $http,$rootScope, $stateParams,cacheService,LoaderService) {
		$rootScope.headColor = 'winmaker_bg';
		$scope.cache= cacheService;
		if(undefined === $rootScope.prods) {
			$rootScope.prods = JSON.parse(window.localStorage['prods']);
			$rootScope.selectedItem = $rootScope.prods[0];			
		}
		if(''==$stateParams.id ) {
			if(undefined != $scope.cache.maker)
				$stateParams.id = $scope.cache.maker['id'];
			else
				$stateParams.id = $rootScope.cliente.idCliente;
		}
		
        $http.get('https://winclub.winfidelity.com/app/maker/contratti/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {			
				$scope.idAgente = $stateParams.id;
				if(undefined !== $scope.cache.maker && $stateParams.id==$scope.cache.maker['id']) {					
					$scope.nome = $scope.cache.maker['nome'];
					$scope.qualifica = $scope.cache.maker['qualifica'];
					$scope.foto = $scope.cache.maker['foto'];
				}
				else {
					$scope.nome = $rootScope.cliente['nomeMaker'];
					$scope.qualifica = $rootScope.cliente['qualifica'];
					$scope.foto = $rootScope.cliente['foto'];
				}				
				if(undefined !== data['contratti']['pp'] && undefined !== data['contratti']['pp']['desc']) {
					var pp = [];
					pp.push(data['contratti']['pp']);
					$scope.pp = pp; 
				}
				else					
					$scope.pp = data['contratti']['pp'];
				if(undefined !== data['contratti']['pg'] && undefined !== data['contratti']['pg']['desc']) {
					var pg = [];
					pg.push(data['contratti']['pg']);
					$scope.pg = pg; 
				}
				else					
					$scope.pg = data['contratti']['pg'];	

				if($rootScope.loading)
					LoaderService.hide();
										
			})
			.error(function(data){
			
		});
		
		$scope.prodChanged = function(selectedProd) {
			LoaderService.show();
			$rootScope.selectedItem = selectedProd;
			$http.get('https://winclub.winfidelity.com/app/maker/contratti/'+$stateParams.id+'/'+$rootScope.selectedItem.id +'/'+$rootScope.selectedItem.flagOpened)
			.success(function (data) {
				if(undefined !== data['contratti']['pp'] && undefined !== data['contratti']['pp']['desc']) {
					var pp = [];
					pp.push(data['contratti']['pp']);
					$scope.pp = pp; 
				}
				else					
					$scope.pp = data['contratti']['pp'];
				if(undefined !== data['contratti']['pg'] && undefined !== data['contratti']['pg']['desc']) {
					var pg = [];
					pg.push(data['contratti']['pg']);
					$scope.pg = pg; 
				}
				else					
					$scope.pg = data['contratti']['pg'];	

				if($rootScope.loading)
				LoaderService.hide();					
			})
			.error(function(data){
			
		});
		};

    })
	
	.controller('LogoutCtrl', function($scope, AuthenticationService) {
		AuthenticationService.logout();
	})


